"use strict";
/* eslint-disable @typescript-eslint/ban-ts-comment */
// @ts-nocheck
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBaseReducer = exports.createReducer = void 0;
const immer_1 = require("immer");
/**
 * A helper to create reducers (uses immer)
 */
const createReducer = function (DEFAULT, ...mixins) {
    const reducer = (0, exports.createBaseReducer)(DEFAULT, ...mixins);
    return function (state = DEFAULT, action) {
        if ((0, immer_1.isDraft)(state) || !(0, immer_1.isDraftable)(state))
            return reducer(state, action);
        return (0, immer_1.default)(state, (draft) => reducer(draft, action));
    };
};
exports.createReducer = createReducer;
/**
 * A helper to create reducers (without immer)
 */
const createBaseReducer = function (DEFAULT, ...mixins) {
    const reducers = Object.assign({}, ...mixins);
    return function (state = DEFAULT, action) {
        const producer = reducers[action.type];
        if (producer)
            state = producer(state, action);
        return state;
    };
};
exports.createBaseReducer = createBaseReducer;
