import { Reducer, Store } from 'redux'
export declare const REHYDRATE = 'persist/rehydrate'
export declare const PURGE = 'persist/purge'
export declare const PAUSE = 'persist/pause'
export declare const PERSIST = 'persist/persist'
export declare const localStorage: {
  setItem: (key: any, value: any) => Promise<unknown>
  getItem: (key: any) => Promise<unknown>
}
export declare const sessionStorage: {
  setItem: (key: any, value: any) => Promise<unknown>
  getItem: (key: any) => Promise<unknown>
}
export declare type PersistConfig = {
  key: string
  storage: {
    setItem: (key: string, value: any) => Promise<any>
    getItem: (key: string) => Promise<any>
  }
  stringify?: (state: any) => string
  parse?: (stored: string) => any
  merge?: <S>(stored: S, state: S) => S
  throttle?: number
}
export declare const persistReducer: (
  config: PersistConfig,
  reducer: Reducer,
) => (state: any, action: any) => any
export declare const persistStore: (store: Store) => {
  purge: (key: any) => void
  pause: (key: any) => void
  persist: (key: any) => void
}
